Package org.apache.storm.security.auth

## Interface ITransportPlugin

- All Known Implementing Classes:
    `DigestSaslTransportPlugin`, `KerberosSaslTransportPlugin`, `PlainSaslTransportPlugin`, `SaslTransportPlugin`, `SimpleTransportPlugin`, `SingleUserSimpleTransport`, `TlsTransportPlugin`

      public interface ITransportPlugin

  Interface for Thrift Transport plugin.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default boolean` | `areWorkerTokensSupported()` | Check if worker tokens are supported by this transport.
    `org.apache.storm.thrift.transport.TTransport` | `connect​(org.apache.storm.thrift.transport.TTransport transport, String serverHost, String asUser)` | Connect to the specified server via framed transport.
    `int` | `getPort()` | Get port.
    `org.apache.storm.thrift.server.TServer` | `getServer​(org.apache.storm.thrift.TProcessor processor)` | Create a server associated with a given port, service handler, and purpose.
    `void` | `prepare​(ThriftConnectionType type, Map<String,​Object> topoConf)` | Invoked once immediately after construction.

- - ### Method Detail

    - #### prepare

          void prepare​(ThriftConnectionType type,
                       Map<String,​Object> topoConf)

      Invoked once immediately after construction.
      Parameters:
        `type` - the type of connection this will process.
        `topoConf` - Storm configuration

    - #### getServer

          org.apache.storm.thrift.server.TServer getServer​(org.apache.storm.thrift.TProcessor processor)
                                                    throws IOException,
                                                           org.apache.storm.thrift.transport.TTransportException

      Create a server associated with a given port, service handler, and purpose.
      Parameters:
        `processor` - service handler
      Returns:
        server
      Throws:
        `IOException`
        `org.apache.storm.thrift.transport.TTransportException`

    - #### connect

          org.apache.storm.thrift.transport.TTransport connect​(org.apache.storm.thrift.transport.TTransport transport,
                                                               String serverHost,
                                                               String asUser)
                                                        throws IOException,
                                                               org.apache.storm.thrift.transport.TTransportException

      Connect to the specified server via framed transport.
      Parameters:
        `transport` - The underlying Thrift transport.
        `serverHost` - server host
        `asUser` - the user as which the connection should be established, and all the subsequent actions should be executed. Only applicable when using secure storm cluster. A null/blank value here will just indicate to use the logged in user.
      Throws:
        `IOException`
        `org.apache.storm.thrift.transport.TTransportException`

    - #### getPort

          int getPort()

      Get port.
      Returns:
        The port this transport is using. This is not known until `getServer(org.apache.storm.thrift.TProcessor)` has been called

    - #### areWorkerTokensSupported

          default boolean areWorkerTokensSupported()

      Check if worker tokens are supported by this transport.
      Returns:
        true if they are else false.